<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Izg project: queue/src/queue/queue.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Izg project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_a5212ee8b6a8d592d027941e58e3651c.html">queue</a></li><li class="navelem"><a class="el" href="dir_821be63df25109e5eb77dd0f2b80706a.html">src</a></li><li class="navelem"><a class="el" href="dir_e311e002a24b0cb5a76159e0ee0c544b.html">queue</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">queue.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file contains declaration of queue.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;stdint.h&gt;</code><br />
<code>#include &lt;errorCodes/errorCodes.h&gt;</code><br />
<code>#include &lt;<a class="el" href="queue_2src_2queue_2fwd_8h_source.html">queue/fwd.h</a>&gt;</code><br />
<code>#include &lt;queue/queue_export.h&gt;</code><br />
</div>
<p><a href="queue_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structQueue.html">Queue</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This struct represents queue.  <a href="structQueue.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a37211e1ceb4d4f2ff1e3307ca9cae7dd"><td class="memItemLeft" align="right" valign="top"><a id="a37211e1ceb4d4f2ff1e3307ca9cae7dd"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a37211e1ceb4d4f2ff1e3307ca9cae7dd">QUEUE_FRONT</a>&#160;&#160;&#160;0</td></tr>
<tr class="memdesc:a37211e1ceb4d4f2ff1e3307ca9cae7dd"><td class="mdescLeft">&#160;</td><td class="mdescRight">front element of the queue <br /></td></tr>
<tr class="separator:a37211e1ceb4d4f2ff1e3307ca9cae7dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace4353596ccfb99587bf0fddb48b23eb"><td class="memItemLeft" align="right" valign="top"><a id="ace4353596ccfb99587bf0fddb48b23eb"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#ace4353596ccfb99587bf0fddb48b23eb">QUEUE_BACK</a>&#160;&#160;&#160;1</td></tr>
<tr class="memdesc:ace4353596ccfb99587bf0fddb48b23eb"><td class="mdescLeft">&#160;</td><td class="mdescRight">back element of the queue <br /></td></tr>
<tr class="separator:ace4353596ccfb99587bf0fddb48b23eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a69189dcc78a0bf11ccaa54679638feb2"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a69189dcc78a0bf11ccaa54679638feb2">queue_init</a> (<a class="el" href="structQueue.html">Queue</a> *const queue, uint32_t elementSize)</td></tr>
<tr class="memdesc:a69189dcc78a0bf11ccaa54679638feb2"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits queue.  <a href="#a69189dcc78a0bf11ccaa54679638feb2">More...</a><br /></td></tr>
<tr class="separator:a69189dcc78a0bf11ccaa54679638feb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00748c2396c3bfbe932890857e01bd2d"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a00748c2396c3bfbe932890857e01bd2d">queue_free</a> (<a class="el" href="structQueue.html">Queue</a> *const queue)</td></tr>
<tr class="memdesc:a00748c2396c3bfbe932890857e01bd2d"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function frees queue.  <a href="#a00748c2396c3bfbe932890857e01bd2d">More...</a><br /></td></tr>
<tr class="separator:a00748c2396c3bfbe932890857e01bd2d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab38246fcaecc01a00a5667421904c0e7"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#ab38246fcaecc01a00a5667421904c0e7">queue_empty</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue)</td></tr>
<tr class="memdesc:ab38246fcaecc01a00a5667421904c0e7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns 1 if the queue is empty.  <a href="#ab38246fcaecc01a00a5667421904c0e7">More...</a><br /></td></tr>
<tr class="separator:ab38246fcaecc01a00a5667421904c0e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b195a91fe699363e88e8432ac88ebf8"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a0b195a91fe699363e88e8432ac88ebf8">queue_elements</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue)</td></tr>
<tr class="memdesc:a0b195a91fe699363e88e8432ac88ebf8"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns the number of elements in the queue.  <a href="#a0b195a91fe699363e88e8432ac88ebf8">More...</a><br /></td></tr>
<tr class="separator:a0b195a91fe699363e88e8432ac88ebf8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9df6a622f07cbdee9aef35dac61bac7a"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a9df6a622f07cbdee9aef35dac61bac7a">queue_elementSize</a> (<a class="el" href="structQueue.html">Queue</a> const *const queue)</td></tr>
<tr class="memdesc:a9df6a622f07cbdee9aef35dac61bac7a"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns the element size in bytes.  <a href="#a9df6a622f07cbdee9aef35dac61bac7a">More...</a><br /></td></tr>
<tr class="separator:a9df6a622f07cbdee9aef35dac61bac7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc7ee81999a19795e7955a8ab16b11fa"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT ErrorCode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#afc7ee81999a19795e7955a8ab16b11fa">queue_push</a> (<a class="el" href="structQueue.html">Queue</a> *const queue, void *const value)</td></tr>
<tr class="memdesc:afc7ee81999a19795e7955a8ab16b11fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pushes a new value to the end of the queue.  <a href="#afc7ee81999a19795e7955a8ab16b11fa">More...</a><br /></td></tr>
<tr class="separator:afc7ee81999a19795e7955a8ab16b11fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c56516f39eb7a5c023baa720a05c76b"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT ErrorCode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a8c56516f39eb7a5c023baa720a05c76b">queue_pop</a> (<a class="el" href="structQueue.html">Queue</a> *const queue, void *const value)</td></tr>
<tr class="memdesc:a8c56516f39eb7a5c023baa720a05c76b"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pops elements from the front of the queue.  <a href="#a8c56516f39eb7a5c023baa720a05c76b">More...</a><br /></td></tr>
<tr class="separator:a8c56516f39eb7a5c023baa720a05c76b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9dc2ac29d78d98ec6b7a4d8aad8e176c"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#a9dc2ac29d78d98ec6b7a4d8aad8e176c">queue_front</a> (<a class="el" href="structQueue.html">Queue</a> *const queue)</td></tr>
<tr class="memdesc:a9dc2ac29d78d98ec6b7a4d8aad8e176c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function return front element data.  <a href="#a9dc2ac29d78d98ec6b7a4d8aad8e176c">More...</a><br /></td></tr>
<tr class="separator:a9dc2ac29d78d98ec6b7a4d8aad8e176c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aea5a5ed4c2683b71712f67a670b8608d"><td class="memItemLeft" align="right" valign="top">QUEUE_EXPORT void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="queue_8h.html#aea5a5ed4c2683b71712f67a670b8608d">queue_back</a> (<a class="el" href="structQueue.html">Queue</a> *const queue)</td></tr>
<tr class="memdesc:aea5a5ed4c2683b71712f67a670b8608d"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function return back element data.  <a href="#aea5a5ed4c2683b71712f67a670b8608d">More...</a><br /></td></tr>
<tr class="separator:aea5a5ed4c2683b71712f67a670b8608d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file contains declaration of queue. </p>
<dl class="section author"><dt>Author</dt><dd>Tomáš Milet, <a href="#" onclick="location.href='mai'+'lto:'+'imi'+'le'+'t@f'+'it'+'.vu'+'tb'+'r.c'+'z'; return false;">imile<span style="display: none;">.nosp@m.</span>t@fi<span style="display: none;">.nosp@m.</span>t.vut<span style="display: none;">.nosp@m.</span>br.c<span style="display: none;">.nosp@m.</span>z</a> </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="aea5a5ed4c2683b71712f67a670b8608d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aea5a5ed4c2683b71712f67a670b8608d">&#9670;&nbsp;</a></span>queue_back()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT void* queue_back </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function return back element data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>back element data or NULL if the queue is empty </dd></dl>

</div>
</div>
<a id="a0b195a91fe699363e88e8432ac88ebf8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0b195a91fe699363e88e8432ac88ebf8">&#9670;&nbsp;</a></span>queue_elements()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT uint32_t queue_elements </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns the number of elements in the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of elements in the queue </dd></dl>

</div>
</div>
<a id="a9df6a622f07cbdee9aef35dac61bac7a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9df6a622f07cbdee9aef35dac61bac7a">&#9670;&nbsp;</a></span>queue_elementSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT uint32_t queue_elementSize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns the element size in bytes. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>element size in bytes </dd></dl>

</div>
</div>
<a id="ab38246fcaecc01a00a5667421904c0e7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab38246fcaecc01a00a5667421904c0e7">&#9670;&nbsp;</a></span>queue_empty()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT int queue_empty </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> const *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns 1 if the queue is empty. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 if queue is empty, 0 otherwise </dd></dl>

</div>
</div>
<a id="a00748c2396c3bfbe932890857e01bd2d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a00748c2396c3bfbe932890857e01bd2d">&#9670;&nbsp;</a></span>queue_free()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT void queue_free </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function frees queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9dc2ac29d78d98ec6b7a4d8aad8e176c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9dc2ac29d78d98ec6b7a4d8aad8e176c">&#9670;&nbsp;</a></span>queue_front()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT void* queue_front </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function return front element data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>front element data or NULL if the queue is empty </dd></dl>

</div>
</div>
<a id="a69189dcc78a0bf11ccaa54679638feb2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a69189dcc78a0bf11ccaa54679638feb2">&#9670;&nbsp;</a></span>queue_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT void queue_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>elementSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">elementSize</td><td>size of one element in bytes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8c56516f39eb7a5c023baa720a05c76b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c56516f39eb7a5c023baa720a05c76b">&#9670;&nbsp;</a></span>queue_pop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT ErrorCode queue_pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *const&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pops elements from the front of the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">value</td><td>the elements value of the queue</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>return ERR_OK on success </dd></dl>

</div>
</div>
<a id="afc7ee81999a19795e7955a8ab16b11fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afc7ee81999a19795e7955a8ab16b11fa">&#9670;&nbsp;</a></span>queue_push()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">QUEUE_EXPORT ErrorCode queue_push </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structQueue.html">Queue</a> *const&#160;</td>
          <td class="paramname"><em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *const&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pushes a new value to the end of the queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">queue</td><td>queue </td></tr>
    <tr><td class="paramname">value</td><td>a new value</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>return ERR_OK on success </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Apr 23 2019 13:21:21 for Izg project by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
